#include "ptz_struct.h"
#include "bsp_os.h"
#include "sock_utils.h"
#include "ptz_type_select.h"
#include "ptz_global_variable.h"

//ڱ̨ĸ״̬
PtzState g_ptz;

//ԴƳʼ
void ptz_aux_switch_init()
{
    //ʱʹ
  rcu_periph_clock_enable(RCU_GPIOE);
  
  gpio_mode_set(GPIOE, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_3);
  gpio_output_options_set(GPIOE, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_3);
  
  gpio_mode_set(GPIOE, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_2);
  gpio_output_options_set(GPIOE, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_2);
  
  PHOTO_POWER_PHOTO_OFF;
  g_ptz.power.aux_switch_3 = POWER_OFF;
  
  FARIR_POWER_FARIR_OFF;
  g_ptz.power.aux_switch_4 = POWER_OFF;
}

void ptz_return_clear()
{//ش־
  g_ptz.preset_bit_return.preset_bit_location_cmd  = 0;
  g_ptz.location_return.hori_cmd = 0;
  g_ptz.location_return.vert_cmd = 0;
}

/*
 ******************************************************************************
 *              
 *                            汾˵
 *
 *   1汾šg_program_version_numberеbin,hpkļһ
 *   2̨͡g_ptz_typeݰ̨ͺţӲ汾ţԼԼȹ
 *   
 *   汾̨ͺţд+װͺţд+汾
 *
 *   24Vϸ̨Ϊɵ汾HW17_01A-3S24_BLDC_V10-SV10_21112401
 *
 *  ̨ͺţHW17_01A
 *  1̨ʶ      L--    M--    H--  ......
 *  2̨ʽʶ    W--ϸ    Z--ֱ  ......
 *  3̨ݣ        17--2017귢  ......
 *  4̨ͺűʶ        01A  ......
 *  װͺţ3S24_BLDC_V10
 *  5̨Ӳӿڣ        3S--3ڽӿ  ......
 *  6̨ײѹ        24--24V   12--12V  ......
 *  7̨        BLDC--ˢֱ   STEP--  ......
 *  8װͺţ            V10  ......
 *  汾ţSV10_21032401
 *  9汾Ź̶֣    SV
 *  10̨汾ͺţ   10--MK60_PTZ   20--Hyt2.0  ......
 *  11̨ڣ    211119--211119  ......
 *  12κţ          01  ......
 *  ̨ͺװͺ֮ԡ-Ϊ
 *
 ******************************************************************************
 */  
  

//====ֱˢ-L6235D-ֱ-̨-24V******02AΪɽ̨
#ifdef PTZ_LIGHT_GEAR_L6235D_AS5047D
    unsigned char g_program_version_number[50] = "MZ17_02A-3S24_BLDC_V20-SV20_22122301";
    unsigned char g_ptz_type[60] = "HY-MZYT-02A_/_3S24_BLDC_V20-SIX_STEP/_NC_/_NO_//";
#endif    

//====ֱˢ-L6235D-ϸ-̨-24V
#ifdef PTZ_MEDIUM_WORM_L6235D_AS5047D
    unsigned char g_program_version_number[50] = "MW22_01A-3S24_BLDC_V20-SV20_22052001";
    unsigned char g_ptz_type[60] = "HY-MWYT-01A_/_3S24_BLDC_V20-SIX_STEP/_NC_/_NO_//";
#endif    
    
//====ֱˢ-L6235D-ϸ-̨-24V
#ifdef PTZ_HEAVY_WORM_L6235D_AS5047D
    unsigned char g_program_version_number[50] = "HW17_01A-3S24_BLDC_V11-SV20_22052001";
    unsigned char g_ptz_type[60] = "HY-HWYT-01A_/_3S24_BLDC_V11-SIX_STEP/_NC_/_NO_//";
#endif     
    
//====ֱˢ-L6235D-ϸ-̨-24V
#ifdef PTZ_SUPER_LIGHT_WORM_L6235D_AS5047D_24V
    unsigned char g_program_version_number[50] = "LW21_01B-3S24_BLDC_V20-SV20_24052101";//"LW21_01B-3S24_BLDC_V20-SV20_23062001";//"LW21_01B-3S24_BLDC_V20-SV20_23021001";
    unsigned char g_ptz_type[60] = "HY-LWYT-01B_/_3S24_BLDC_V20-SIX_STEP/_NC_/_NO_//";
#endif     

//====ֱˢ-L6235D-ϸ-̨-12V
#ifdef PTZ_SUPER_LIGHT_WORM_L6235D_AS5047D_12V
    unsigned char g_program_version_number[50] = "LW21_01A-3S12_BLDC_V20-SV20_22052001";
    unsigned char g_ptz_type[60] = "HY-LWYT-01A_/_3S24_BLDC_V20-SIX_STEP/_NC_/_NO_//";
#endif
    
    
    
    
//====-TMC2160-ϸ-̨-24V
#ifdef PTZ_SUPER_LIGHT_WORM_STEP_TMC2160_AS5047D_24V    
    
    unsigned char g_program_version_number[50] = "LW21_02B-3S24_STEP_V20-SV20_22071201";
    unsigned char g_ptz_type[60] = "HY-LWYT-02B_/_3S24_STEP_V20-TMC/_NC_/_NO_//";
    
#endif
//====-TMC2160-ϸ-̨-24V
#ifdef PTZ_MEDIUM_WORM_STEP_TMC2160_AS5047D_24V    
    
    unsigned char g_program_version_number[50] = "MW22_02A-3S24_STEP_V20-SV20_22071101";
    unsigned char g_ptz_type[60] = "HY-MWYT-02A_/_3S24_STEP_V20-TMC/_NC_/_NO_//";
    
#endif  


